/*
 Bengol compiler
 tables and defines 
*/
#define SYMAX   250 /* 250 */
#define SSYMAX  2250 /* 2250*9 */
#define TERMAX  35  /* TERMS per statment */

#define SPACE   32
#define SQUOTE  39
#define DQUOTE  34
#define BSLASH  92
/* data types for simple operations */
#define MSUB  0
#define MADD  1
#define MLD   2
#define MXOR  5
#define MST   6
#define MEFA  7
#define MADX  8
#define MCAD  10
#define MAXH  11
/* acc A or X */
#define VAC  0
#define VIX  1
/* test */
#define BREQ 3
#define BRA  6
/* operand types */
#define VCON 1
#define VVAR 2
#define VPTR 4
#define VIDX 8
#define VLOCX 16
#define VSTR 32
#define BSZ   1
#define HSZ   2
#define RSZ   4
#define STACK 1
#define BP    3
/* TYPES */
#define Tnoop 1
/* no function */
#define Tlit  2
/* string lit   */
#define Tnum  3
/* int number */
#define Tid   4
/* name of some kind or operand */
/* KEYWORDS */
#define Tkon  5
#define Ttag  6
#define Tint  7
#define Trec  8 
#define Treal 9 
#define Tshort 10
#define Tchar 11
#define Tstop 12
#define Tend  13
#define Teif  14
#define Telse 15
#define Tfi   16
#define Tloop 17
#define Tuntil 18
#define Tif   19
#define Twhile 20
/* while c ... repeat */
#define Tdo   21
/* do .. repeat c */
#define Tret  22
/* ret     */
#define Tun   23
/* unsigned */
#define Tand  25
#define Tsub  26 /* subroutine call */
#define Tnot  27
/* OPERANDS  UNARY */
#define Tefa  28
#define Trp   29  /* ) */
#define Tset  30
/* OPRANDS BINARY  */
#define Tbool 31
#define Tcmp  32
#define Top   33
#define Tfop  34
#define Tlb   35
#define Trb   36
#define Tlp   37  /* ( */
#define Tarrow 38 /* -> */
#define Tgo   39  /* goto */
#define Tlab  40  /* label */
#define Tcont 41  /* continue */
#define Tbk  42  /* break */
#define Tbgn  43  /* begin */
#define Tstart 44 /* start */
#define Tlbr  45  /* { */
#define Trbr  46  /* } */
#define Tcomma  47  /* comma */
#define Tsemi 48  /* ;  */
#define Torg  49
#define Tpage 50
#define Tbug  51


#define BPW 4   /* BYTES PER WORD */
#define BPH 2   /* HALF (short)   */
#define BPS 28  /* BYTES PER STACK 14/28 */
#define BPSP 32 /* TOTAL STACK OFFSET */

#define ISARG   1
#define ISLIT   2
#define ISLP    3
#define ISCALL  4

/* term returns */
#define QANUM   0x01
#define ISANUM  0x02
/* alpha numeric */
#define QNUM    0x10
#define ISNUM   0x20
/* number      */
#define QSOP    0x04
/* single  char operand */
#define QDOP    0x40
/* multi   char operand */
#define QSPACE  0x80
/* while space */
#define QUNARY  0x08
/* unary or constant ops  */
char _is[128] = {
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x80, 0x80, 0x00, 0x00, 0x80, 0x00, 0x00,
 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
 0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00,
/*     a      b    c     d      e     f     g
 h     i      j    k     l      m     n     o
 p     q      r    s     t      u     v     w
 x     y      z                              */
/* control chars */
 0x80, 0x00, 0x04, 0x0C, 0x30, 0x04, 0x40, 0x04,
 0x04, 0x04, 0x0C, 0x0C, 0x04, 0x60, 0x30, 0x04,
 0x32, 0x32, 0x32, 0x32, 0x32, 0x32, 0x32, 0x32,
 0x32, 0x32, 0x04, 0x04, 0x40, 0x40, 0x40, 0x00,
/* SPACE !    "     #    $     %      &    '
 (     )      *    +     ,      -     .     /
 0     1      2    3     4      5     6     7
 8     9      :    ;     <      =     >     ? */
/* operands */
 0x00, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x03,
 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03,
 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03,
 0x03, 0x03, 0x03, 0x04, 0x00, 0x04, 0x04, 0x03,
/* @   A      B    C     D      E     F     G
 H     I      J    K     L      M     N     O
 P     Q      R    S     T      U     V     W
 X     Y      Z    [     \      ]     ^     _ */
/* upper case */
 0x00, 0x23, 0x23, 0x23, 0x23, 0x23, 0x23, 0x03,
 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03,
 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03, 0x03,
 0x03, 0x03, 0x03, 0x04, 0x04, 0x04, 0x0C, 0x80
/* `   a      b    c     d      e     f     g
 h     i      j    k     l      m     n     o
 p     q      r    s     t      u     v     w
 x     y      z    {     |      }     ~     DEL  */
/* lower case */
 };
