/*
 Bengol compiler ASCI INPUT
 Line input and token routines

*/

/* print error and exit program reading */
void bad(char *s)
{
printf("Line# %d %s '%s' \n#%s",lineno,s,token,line);
if(fout!=NULL) fclose(fout);
if(fina!=NULL)  fclose(fina);
if(finb!=NULL)  fclose(finb);
exit(0);
}

void bugs()
{
 if(verbose&8) fprintf(fout,"*** %s ***\n",token);
}

/* read a line */
/* . beginning of line just echo to output asembler input */
/*   verbose bit 2 print line to tty  bit 3 line to lineout file */
/*   can return a empty line */
void getmore() {
 lp = 0;
 line[0]=0;
 while(nomore==0){
    if(finb!=NULL) fin=fgets(line,80,finb); /* include input */
    else           fin=fgets(line,80,fina); /* normal input */
    while(fin!=NULL)
    {
    lineno=lineno+1;
    /* echo output ?*/
    if(verbose & 2)
        printf("%s",line);
    if(fout!=NULL && verbose & 4)
        fprintf(fout,"/%s",line);
    if(line[0]=='.'){  /* null input */
        fprintf(fout,"%s",line+1);
        line[0]=0;}
    if(line[0]=='#')
        domore(); /* null input */
    return;
   }
  if(finb==NULL) nomore=1;
  else{
  fclose(finb);
  finb=NULL;
  }
 }
 /* error null input */
 line[0]=0;
}

 /* #file   include */
 domore()
 {
 int i;
 i=1;
 while(line[i]> SPACE) i=i+1;
 line[i]=0;
 finb=NULL;
 if(i!=1) finb=fopen(&line[1],"r");
 if(finb==NULL)
 {
  printf("Line#%d %s Include file error\n",lineno,line);
  if(fout!=NULL) fclose(fout);
  if(fina!=NULL) fclose(fina);
  exit(0);
 }
  line[0]=0;
}


/* skip white or comments */
void skipw()
{
int i,ch;
  while(nomore==0){
    ch=line[lp]&127;
    while(_is[ch]&QSPACE)
    { lp=lp+1;
      ch=line[lp]&127;}
    if(ch=='-') {
        i=lp+1;
        if(line[i]!='-') return;}
      else if(ch=='/') {
        i=lp+1;
        if(line[i]!='*') return;}
      else if(ch) return; 
   
  /* end of string or '--' or c comment */
  getmore();
 }
}

/* get number n  0 leading octal  unsigned  $ hex */
getnum(){
int i,m,n,k;
 i=0;
 n=10;
 m=0;
 if(token[i]=='-'){ i=i+1;m=1;}
 if(token[i]=='$'){ n=16;i=1;}
 if(token[i]=='0')n=8;

 while (token[i]) {
  k=token[i]-'0'; if(k > 9) k = k - 7;
  lookv = k +(lookv*n);
  i=i+1;}
  if(m) lookv = - lookv;
 look=Tnum;
}


/* get literal ' */
/* '<char>  '\n '\\ */
litch()
{
 
 lookv=line[lp];
 if(lookv>=' ')
 { lp=lp+1;
   if(lookv==BSLASH) /* \ */
   {
   lookv=line[lp];
   if(lookv>=' ')
    {
    lp=lp+1;
    if(lookv=='n') lookv=10;
    }
   }
 if(line[lp]==SQUOTE) lp=lp+1;
 } 
 look = Tnum;
}
/* get literal string "" */

lits()
{
	int c;
    
 	  lookv=litptr;
    c=line[lp];
	lp=lp+1;
	while (c!= DQUOTE)
		{
		if(litptr>=2048) over("String ");
    if(c<SPACE)bad("String not terminated");
		if(c==BSLASH) { /* back slash */
			/* no EOL check */
            c=line[lp];
            if(c<=' ')bad("Bad Escape char");
			lp=lp+1;

  		if(c=='n') c=10;
      if(c=='0') c =0;
			if(c=='t') c =9;
			}
		litq[litptr]=c;
        litptr=litptr+1;
        c=line[lp];
	    lp=lp+1;
		}
 	litq[litptr]=0;
	litptr=litptr+1;
  look=Tlit;
}

/* get a token input and skip trailing white*/
atoken(int m)
{
int ch,i;
i=0;
ch=line[lp]&127;

 while(_is[ch]&m)
  {
  if (ch>='a') ch=ch-32;
  token[i]=ch;
  if(i<12)i=i+1;
  lp=lp+1;
  ch=line[lp]&127;

  }
 token[i]=0;
 
/* skip white on line */
    while(_is[ch]&QSPACE)
    { lp=lp+1;
      ch=line[lp]&127;}   
}

void getoken()
{
int i,ch,t,n;
skipw();
i=0;
token[1]=0;
ch=line[lp]&127;
token[0]=ch;
look=Tid;
lookv=0;

/* single char input */
t=_is[ch];
if(t==0) bad("Invalid char");
if(t&QSOP) 
 {
 lp=lp+1;
 if(ch==DQUOTE) lits();
 if(ch==SQUOTE) litch();
 return ;
 }

if(t&QDOP)
 {
 n=lp+1; 
 if(ch=='-' && line[n]>='0' && line[n]<='9')
  {
   atoken(ISNUM);getnum();
  }
 else
  atoken(QDOP);
 return ;} 
if(t&QNUM)
 { atoken(ISNUM);getnum();
   return;}
/* all that is left is Id/Operation or procedure/Function call */

 atoken(ISANUM);
 if(line[lp]=='(') look=Tsub;
 if(line[lp]==':'){lp=lp+1; look=Tlab;} /*  label */
}
/* look for unary or constant operand */

int unary()
{
int ch;
skipw();
ch=line[lp]&127;
if((_is[ch]&QUNARY)==0) return 0;
return ch;
}

